/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mozilla.org code.
 *
 * The Initial Developer of the Original Code is
 * Mozilla.org.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Dan Yamaoka
 *
 * ***** END LICENSE BLOCK ***** */

/*----------------------
 CookieCuller 1.1.0
 Dan Yamaoka
 Original CookieManager code is from Mozilla Firefox v0.8, CookieViewer.js
 Modified original code is commented with "//DY" (I hope)
 
 History:
 1.1.0 New code for deleting unprotected cookies at browser startup
 ----------------------*/
 
 var CookieCullerStartup = {
 	handleEvent: function()
 	{
 		window.removeEventListener("load", CookieCullerStartup, true);

                var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].
                            getService(Components.interfaces.nsIWindowMediator);
 		var enumerator = wm.getEnumerator(null);
 		var domWindow = enumerator.getNext("navigator:browser");
 		if (!enumerator.hasMoreElements()) {
                        var cookieculler_prefs = Components.classes["@mozilla.org/preferences-service;1"].
                               getService(Components.interfaces.nsIPrefService).
                               getBranch("extensions.cookieculler_options.");
                        if (cookieculler_prefs.prefHasUserValue("delUnprotAtStartup")) {
                        	if (cookieculler_prefs.getBoolPref("delUnprotAtStartup")) {
                        		deleteUnprotectedCookies();
                                }
                        }
 		}
 	}
 }

 function Cookie(number,name,host,path) {
  this.number = number;
  this.name = name;
  this.host = host;
  this.path = path;
 }
 
 function deleteUnprotectedCookies() {
 	var unprotcookies = [];
 	var savedcookies = [];
 	var cookieculler_prefs = Components.classes["@mozilla.org/preferences-service;1"].
                                   getService(Components.interfaces.nsIPrefService).
                                   getBranch("extensions.cookieculler.");
        var cookiemanager = Components.classes["@mozilla.org/cookiemanager;1"].getService();
        cookiemanager = cookiemanager.QueryInterface(Components.interfaces.nsICookieManager);
        var enumerator = cookiemanager.enumerator;
        const cookiepref = "pcookie";
        const cookieprefdelimiter = ";";
 	var savecount = 0;
 	var truecount = 0;
 	var delcount = 0;
 	var cpath;
 	var cname;
 	var chost;
 	  
 	if (cookieculler_prefs.prefHasUserValue("count")) {
 		savecount = cookieculler_prefs.getIntPref("count");
 		for (var i=0; i<savecount; i++) {
 		       if (cookieculler_prefs.prefHasUserValue(cookiepref + i)) {
 			     var protectedcookie = cookieculler_prefs.getCharPref(cookiepref + i);
 			     var secondDelimiter = protectedcookie.lastIndexOf(cookieprefdelimiter);
 			     cpath = protectedcookie.slice(secondDelimiter+1);
 			     var firstDelimiter = protectedcookie.lastIndexOf(cookieprefdelimiter,secondDelimiter-1);
 			     cname = protectedcookie.slice(firstDelimiter+1, secondDelimiter);
 			     chost = protectedcookie.slice(0,firstDelimiter);
 			     savedcookies[truecount] = new Cookie(truecount++, cname, chost, cpath);
 		       }
 		}
 	}
 	while (enumerator.hasMoreElements()) {
 		var matched = false;
 		var nextCookie = enumerator.getNext();
 		if (!nextCookie) break;
 		    nextCookie = nextCookie.QueryInterface(Components.interfaces.nsICookie);
 		    chost = nextCookie.host;
 		    cpath = nextCookie.path;
 		    cname = nextCookie.name;
 		    for (var j=0; j<savedcookies.length; j++) {
                       if ( (savedcookies[j].host == chost) && (savedcookies[j].path == cpath) && (savedcookies[j].name == cname) ) {
                       	    matched = true;
                            break;
                       }
                    }
                    if (!matched) {
                          unprotcookies[delcount] = new Cookie(delcount++, cname, chost, cpath);
                    }
        }
        
        for (var c=0; c<unprotcookies.length; c++) {
              cookiemanager.remove(unprotcookies[c].host, unprotcookies[c].name, unprotcookies[c].path, false);
        }
 }
 
 window.addEventListener("load", CookieCullerStartup, true);
